#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_BulletHeadCFG.h"
std::auto_ptr<Fish_BulletHeadCFG> Fish_BulletHeadCFG::msSingleton(nullptr);

int Fish_BulletHeadCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_BulletHeadCFGData* Fish_BulletHeadCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_BulletHeadCFGData>& Fish_BulletHeadCFG::GetMapData()
{
	return mMapData;
}

void Fish_BulletHeadCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_BulletHeadCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_BulletHeadCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mAttackMode = element->IntAttribute("AttackMode");
		data.mGemPrice = element->IntAttribute("GemPrice");
		data.mBallPrice = element->IntAttribute("BallPrice");
		data.mGoldKillMin = element->IntAttribute("GoldKillMin");
		data.mGoldKillMax = element->IntAttribute("GoldKillMax");
		data.mThreshold = element->IntAttribute("Threshold");
		{
			const char* RandParam = element->Attribute("RandParam");
			std::vector<std::string> vecRandParam;
			boost::split(vecRandParam, RandParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRandParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRandParam[i].c_str(), &temp))
				{
					data.mRandParam.push_back(temp);
				}
			}
		}
		{
			const char* NoContributeRandParam = element->Attribute("NoContributeRandParam");
			std::vector<std::string> vecNoContributeRandParam;
			boost::split(vecNoContributeRandParam, NoContributeRandParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNoContributeRandParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNoContributeRandParam[i].c_str(), &temp))
				{
					data.mNoContributeRandParam.push_back(temp);
				}
			}
		}
		{
			const char* EverydayBuff = element->Attribute("EverydayBuff");
			std::vector<std::string> vecEverydayBuff;
			boost::split(vecEverydayBuff, EverydayBuff, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecEverydayBuff.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecEverydayBuff[i].c_str(), &temp))
				{
					data.mEverydayBuff.push_back(temp);
				}
			}
		}
		data.mGoldUseMin = element->IntAttribute("GoldUseMin");
		data.mGoldUseMax = element->IntAttribute("GoldUseMax");
		{
			const char* TelephoneDrop = element->Attribute("TelephoneDrop");
			std::vector<std::string> vecTelephoneDrop;
			boost::split(vecTelephoneDrop, TelephoneDrop, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecTelephoneDrop.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecTelephoneDrop[i].c_str(), &temp))
				{
					data.mTelephoneDrop.push_back(temp);
				}
			}
		}
		data.mNotifyMsgCond = element->IntAttribute("NotifyMsgCond");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_BulletHeadCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_BulletHeadCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_BulletHeadCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_BulletHeadCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_BulletHeadCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "AttackMode", data.mAttackMode);
		LuaCfgHelper::readInt(L, "GemPrice", data.mGemPrice);
		LuaCfgHelper::readInt(L, "BallPrice", data.mBallPrice);
		LuaCfgHelper::readInt(L, "GoldKillMin", data.mGoldKillMin);
		LuaCfgHelper::readInt(L, "GoldKillMax", data.mGoldKillMax);
		LuaCfgHelper::readInt(L, "Threshold", data.mThreshold);
		LuaCfgHelper::readVectorInt(L, "RandParam", data.mRandParam);
		LuaCfgHelper::readVectorInt(L, "NoContributeRandParam", data.mNoContributeRandParam);
		LuaCfgHelper::readVectorInt(L, "EverydayBuff", data.mEverydayBuff);
		LuaCfgHelper::readInt(L, "GoldUseMin", data.mGoldUseMin);
		LuaCfgHelper::readInt(L, "GoldUseMax", data.mGoldUseMax);
		LuaCfgHelper::readVectorInt(L, "TelephoneDrop", data.mTelephoneDrop);
		LuaCfgHelper::readInt(L, "NotifyMsgCond", data.mNotifyMsgCond);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_BulletHeadCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_BulletHeadCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_BulletHeadCFG* Fish_BulletHeadCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_BulletHeadCFG());
	}
	return msSingleton.get();
}

void Fish_BulletHeadCFG::Release()
{
	msSingleton.reset(nullptr);
}
